<?php
/*	ex_folder : ex_folder
	name : extended folder
	author: team1/3
	extended folder plugin
	
*/

	global $params,$config;

	if (!isset($config)) { die(); }
	
	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];

	if (empty($params['folder-systag']) && !isset($params['circle']['meta']['folder_systag'])) {
$buff = <<<EOT
		<div style = 'background-color: #FDEBD2;'>
			<h2 style='margin: 10px;padding: 10px 10px 0 10px;'>folder-systag warning</h2>
			<div style = 'padding: 0 0 20px 20px;'>
				<p>\$params['folder-systag'] option is not set.</p>
				<p>ex-folder plugin needs folder-systag option</p>
			</div>
		</div>
EOT;
		$html['article'][] = frame_renderer($buff);
	}

	if (check_rights('owner')) {
		set_func_rights('edit.modules');
		set_func_rights('add_page');
		provide_edit_rights();
	}

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else if (isset($_GET['mode']) && $_GET['mode']=='format') {
		// format編集
		$params['hook']['before_modified'][] = 'ex_folder_onbefore_modified';
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Format Edit');

		$params['hide-editmenu'] = true;
$params['add-editmenu'][] = <<<EOT
		<input type='button' onclick='ot.save_editdata(1)' class='onethird-button mini'  value='save' />
		<input type='button' onclick='ot.open_uploader({select:function(obj){ot.editor.insertimg(obj)}})' class='onethird-button mini' value='image' />
EOT;
		if (isset($page_ar['meta']['format'])) {
			$page_ar['contents'] = $page_ar['meta']['format'];
		} else {
			$page_ar['contents'] = '';
		}
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);
		$buff ='';
		$buff .= ex_folder_renderer($page_ar);

		$html['article'][] = $buff;
	}
}

function ex_folder_onbefore_modified( &$new_ar )
{
	global $params,$config,$ut;

	if (isset($_GET['mode']) && $_GET['mode'] != 'format') {
		return;
	}
	
	//フォーマットの保存処理
	$new_ar['meta']['format'] = $new_ar['contents'];
	$new_ar['metadata'] = serialize64($new_ar['meta']);
	unset($new_ar['meta']);
	unset($new_ar['contents']);
	if (!mod_data_items($new_ar)) {
		if (isset($_POST['ajax'])) {
			echo( json_encode($r) );
			exit();
		}
		exit_proc(400, 'Save-Error');

	} else {

		if ($new_ar['type'] >= 10) {
			event_plugin_page('onmodified', $new_ar);
		}
		
		if (isset($r['url'])) {
			header("Location: {$r['url']}");
		
		} else {
			if ($new_ar['block_type'] == 5) {
				header("Location: {$ut->link($new_ar['link'])}");
			} else {
				header("Location: {$ut->link($new_ar['id'])}");
			}
		}
		
		exit();
	}
}

function ex_folder_renderer( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar;

	$buff = '';
	$contents = '';
	$id = $page_ar['id'];
	$parent_page = $page_ar['id'];		//自ページが親ページ

	$add_type = 1;
	$page_folder_tree = true;
	$desc = $hide_addbtn = $allow_post = false;
	$page_folder_disp_max = 0;
	$page_folder_nest_max = 0;
	$allow_post = !empty($page_ar['meta']['page_folder_allow_post']) && check_rights();
	
	$ar = $database->sql_select_all("select id,metadata from ".DBX."data_items where type=? and id=? ", $page_ar['type'], $id);
	if ($ar) {
		$m = unserialize64($ar[0]['metadata']);
		if (isset($m['page_folder_allow_post'])) { $allow_post = true; }
		if (isset($m['page_folder_add_type'])) { $add_type = $m['page_folder_add_type']; }
		if (isset($m['page_folder_parent_page'])) { $parent_page = $m['page_folder_parent_page']; }
		if (isset($m['page_folder_disp_max'])) { $page_folder_disp_max = $m['page_folder_disp_max']; }
		if (isset($m['page_folder_nest_max'])) { $page_folder_nest_max = $m['page_folder_nest_max']; }
		if (isset($m['page_folder_hide_addbtn'])) { $hide_addbtn = true; }
		if (isset($m['page_folder_desc'])) { $desc = true; }
		if (isset($m['page_folder_tree']) && $m['page_folder_tree']==false) { $page_folder_tree = false; } else {$page_folder_tree = true;}
		if (!isset($m['page_folder_writer'])) {
			if (isset($plugin_ar[ PAGE_FOLDER_ID ]['writer'])) {
				reset($plugin_ar[ PAGE_FOLDER_ID ]['writer']);
				$m['page_folder_writer'] = key($plugin_ar[ PAGE_FOLDER_ID ]['writer']);
			} else {
				$m['page_folder_writer'] = 'std_page_folder_writer';
			}
		}
	}
	if ($allow_post) {
		set_func_rights('add_data_items');
		provide_edit_rights();
	}

	if ($allow_post || isset($params['edit-right']) || check_rights('edit')) {
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_page_folder_setting')  {
			if ((int)$_POST['id'] != $id) {
				return;		// 複数の同種プラグインに対応するため
			}
			$r = array();
			$r['result'] = true;
			$c1 = ($allow_post)?  ' checked ': '';
			$c2 = ($hide_addbtn)?  ' checked ': '';
			$c3 = ($desc)?  ' checked ': '';
			$c4 = ($page_folder_tree)?  ' checked ': '';

$r['html'] = <<<EOT
			<table>
				<tr>
					<td >Parent page</td>
					<td>
						<input type='text' value='$parent_page' data-input='page_folder_parent_page' />
					</td>
				</tr>
				<tr>
					<td >display max count</td>
					<td>
						<input type='text' value='$page_folder_disp_max' data-input='page_folder_disp_max' />
					</td>
				</tr>
				<tr>
					<td >max nest count</td>
					<td>
						<input type='text' value='$page_folder_nest_max' data-input='page_folder_nest_max' />
					</td>
				</tr>
				<tr>
					<td ></td>
					<td>
						<ul>
							<li><label><input type='checkbox' data-input='page_folder_allow_post' $c1 />Allow general users the rights to add data.</label></li>
							<li>
								<label><input type='checkbox' data-input='page_folder_hide_addbtn' $c2 />Hide add button</label>
							</li>
							<li>
								<label><input type='checkbox' data-input='page_folder_desc' $c3 />DESC.</label>
							</li>
							<li>
								<label><input type='checkbox' data-input='page_folder_tree' $c4 />Show Tree</label>
							</li>
						</ul>
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_plugin_page_folder_setting')  {
			if ((int)$_POST['id'] != $id) {
				return;		// 複数の同種プラグインに対応するため
			}
			$r = array();
			$r['result'] = false;

			function _option_save_plugin_page_folder_setting($a, &$page_ar) {
				if (isset($_POST[$a])) {
					$page_ar['meta'][$a] = sanitize_str($_POST[$a]);
				} else {
					if (isset($page_ar['meta'][$a])) { unset($page_ar['meta'][$a]); }
				}
			}
			_option_save_plugin_page_folder_setting('page_folder_allow_post', $page_ar);
			_option_save_plugin_page_folder_setting('page_folder_hide_addbtn', $page_ar);
			_option_save_plugin_page_folder_setting('page_folder_desc', $page_ar);
			_option_save_plugin_page_folder_setting('page_folder_parent_page', $page_ar);
			_option_save_plugin_page_folder_setting('page_folder_disp_max', $page_ar);
			_option_save_plugin_page_folder_setting('page_folder_nest_max', $page_ar);
			_option_save_plugin_page_folder_setting('page_folder_tree', $page_ar);
			
			$page_ar['metadata'] = serialize64($page_ar['meta']);
			if (mod_data_items($page_ar)) {
				$r['result'] = true;
			}
			echo(json_encode($r));
			exit();
		}
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_page_folder_make_page')  {
			$r = array();
			$r['link'] = (int)$_POST['page'];
			$r['result'] = false;
			
			if (empty($_POST['type'])) {
				echo( json_encode($r) );
				exit();
			}
			$r['type'] = (int)($_POST['type']);
			if ($r['type'] == PAGE_FOLDER_ID) {
				$r['title'] = 'Folder';
				$r['block_type'] = 1;
				if (isset($page_ar['meta']['format'])) {
					$r['meta']['format'] = $page_ar['meta']['format'];
				}
				if ($allow_post) {
					$r['meta']['page_folder_allow_post'] = true;
				}
			} else {
				//アイテム用プログラムを指定
				if (isset($page_ar['meta']['format'])) {
					$r['contents'] = $page_ar['meta']['format'];
				}
			}
			create_page( $r );
			if ($r['type'] == PAGE_FOLDER_ID && isset($r['open_url'])) {
				unset($r['open_url']);
			}
			echo( json_encode($r) );
			exit();
		}

		snippet_std_setting('Page folder setting','plugin_page_folder_setting');
$params['add-blockmenu'][] = <<<EOT
		<a href='{$ut->link($page_ar['id'],'&:mode=format')}' class='onethird-button mini'>format</a>
		<a href='javascript:void(ot.plugin_page_folder_reset_cache())' class='onethird-button mini'>reset order</a>
		<a href='javascript:void(ot.plugin_page_folder_setting($id))' class='onethird-button mini'>setting</a>
EOT;
	}

	$contents .= frame_renderer(body_renderer($page_ar));	// 通常ページ部分
	$contents .= innerpage_renderer($page_ar['id']);
	if (isset($params['rendering']) && !$params['rendering']) {
		return ;
	}

	if ($allow_post || isset($params['edit-right']) || check_rights('edit')) {
		if (!isset($html['meta']['plugin_page_folder_make_page'])) {
$html['meta']['plugin_page_folder_make_page'] = <<<EOT
			<script>
			ot.plugin_page_folder_make_page = function (link,type) {
				var opt = "ajax=plugin_page_folder_make_page";
				opt += "&type="+type+"&page="+link;
				ot.ajax({
					type: "POST"
					, url: '{$params['safe_request']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							if ( data['open_url'] ) {
								location.href = data['open_url'];
							} else {
								location.reload(true);
							}
						} else {
							alert('Failure to create a page.');
						}
					}
				});
			};
			</script>
EOT;
		}
	}

	$arg = array('id'=>$parent_page);
	$arg['more'] = true;
	$arg['allow_post'] = $allow_post;
	$arg['desc'] = $desc;
	$arg['page_folder_disp_max'] = $page_folder_disp_max;
	$arg['page_folder_nest_max'] = $page_folder_nest_max;
	$arg['page_folder_tree'] = $page_folder_tree;

	$buff .= ex_folder($arg);
	if (!$hide_addbtn && ($allow_post || check_rights('edit'))) {
		$folder_type = PAGE_FOLDER_ID;
$buff .= <<<EOT
		<p class='add-panel'>
			<input type='button' value='Add page' class='onethird-button mini' onclick='ot.plugin_page_folder_make_page({$parent_page}, $add_type)' />
			<input type='button' value='Add folder' class='onethird-button mini' onclick='ot.plugin_page_folder_make_page({$parent_page}, $folder_type)' />
		</p>
EOT;
	}

	if (!isset($html['head']['plugin-page-folder'])) {
$html['head']['plugin-page-folder'] = <<<EOT
		<style>
			.plugin-page-folder-unit {
				margin-bottom:10px;
			}
			.plugin-page-folder-unit div {
			}
			.plugin-page-folder-unit .item {
				display: table;
				margin:2px 0 2px 0;
			}
			.plugin-page-folder-unit .folder {
				margin-top:5px;
			}
			.plugin-page-folder-unit .drop {
				background-color: #D7D6D6;
			}
			.plugin-page-folder-unit .title {
				color: #286593;
				font-size: 20px;
				margin:0 0 5px 0;
			}
			.plugin-page-folder-unit .onethird-button {
				margin-top:10px;
			}
			.plugin-page-folder-unit .add-panel {
				margin:15px 0 15px 0;
			}
			.plugin-page-folder-unit img {
				vertical-align: middle;
			}
			.plugin-page-folder-unit .date {
				color:#A0A0A0;
				font-size:80%;
				padding-left:5px;
			}
			.plugin-page-folder-unit .new {
				color:#FF7000;
				padding:0 5px;
			}
			.plugin-page-folder-unit .ex_icon {
				width:12px;
				cursor:pointer;
			}
			.plugin-page-folder-unit p {
				color: #3F3F3F;
				padding: 0 1.5em;
				font-size: 80%;
			}
		</style>
EOT;
	}

	return $contents.frame_renderer($buff,'plugin-page-folder-unit');
}


function ex_folder( &$arg )
{
	global $params, $ut, $database, $html;

	$option = array();
	$option['total'] = 0;
	$option['offset'] = 0;
	$option['page_size'] = 30;
	if (isset($arg['page_folder_disp_max'])) {
		$option['page_size'] = $arg['page_folder_disp_max'];
	}
	if (!isset($arg['page_folder_tree'])) {
		$arg['page_folder_tree'] = true;
	}
	if (!isset($arg['page_folder_nest_max'])) {
		$arg['page_folder_nest_max'] = 0;
	}
	
	$mode = '';

	if (isset($_GET['ajax']) && $_GET['ajax'] == '*plugin_page_folder_read')  {
		$arg['id'] = (int)$_GET['link'];
		if (isset($_GET['offset'])) {
			$option['offset'] = (int)$_GET['offset'];
		}
		$mode = ($_GET['mode'] == 'more') ? 'more': 'open';
	}

	$type = 0;
	$offset_name = 'offset';
	$id = $params['page']['id'];
	$more = false;
	if (isset($arg['id'])) {
		$id = $arg['id'];
	}
	if (isset($arg['more'])) {
		$more = true;
	}
	if (isset($arg['offset_name'])) {
		$offset_name = $arg['offset_name'];
	}
	$option['offset_name'] = $offset_name;
	
	$sql = array();
	$sql[0] = "select count(id) as c from ".DBX."data_items ";
	if ($ut->is_home()) {
		//トップページではfolder systag が効かない（意味が無い)
		if ($arg['page_folder_tree']) {
			$sql[1] = array(" where 1 ");
		} else {
			$sql[1] = array(" where link=?  or link=0 ", $id);
		}
	} else {
		if ($arg['page_folder_tree']) {
			$sql[1] = array(" where tag like ? ", "%@dir:%{$id}%/,%");
			$i = (int)$arg['page_folder_nest_max'];
			if ($i > 0 && $i < 10) {
				$x = '';
				for (; $i > 0;--$i) {
					$x .= "%/";
				}
				$sql[1] = array(" where tag not like ? ", "%@dir:%{$id}%/{$x},");
			}
		} else {
			$sql[1] = array(" where link=? ", $id);
		}
	}
	$sql[2] = " and block_type !=5 ";

	$sql[3] = ' and mode<>2 ';
	if (!check_rights()) {
		$sql[3] = ' and mode=1 ';
	} else {
		$sql[3] = array(' and (mode=1 or (mode=0 and user=?)) ', (int)($_SESSION['login_id']));
	}
	$ar = $database->sql_select_all($sql);
	if ($ar) {
		$option['total'] = $ar[0]['c'];
	}
	if (isset($_GET[$offset_name])) {
		$option['offset'] = (int)$_GET[$offset_name];
	}
	if (isset($arg['page_size'])) {
		$option['page_size'] = (int)$arg['page_size'];
	}

	
	$buff = '';
	// write foloder
	$sql[0] = "select id,type,metadata,title,mode,user,date,link,block_type from ".DBX."data_items ";
	if (check_rights('edit')) {
		$sql[4] = array(' and type=? ',PAGE_FOLDER_ID);
	} else if (check_rights()) {
		$sql[4] = array(' and type=? and block_type <= 15 ',PAGE_FOLDER_ID);
	} else {
		$sql[4] = array(' and type=? and block_type <= 20 ',PAGE_FOLDER_ID);
	}
	$sql[5] = 'order by date asc';
	if (!empty($arg['desc'])) {
		$sql[5] = 'order by date desc';
	}

	$folder_ar = $database->sql_select_all($sql);

	// write page
	if (check_rights('edit')) {
		$sql[4] = array(' and type<>? ',PAGE_FOLDER_ID);
	} else if (check_rights()) {
		$sql[4] = array(' and type<>? and block_type <= 15 ',PAGE_FOLDER_ID);
	} else {
		$sql[4] = array(' and type<>? and block_type <= 20 ',PAGE_FOLDER_ID);
	}
	if (!$arg['page_folder_tree'] && $option['page_size']) {
		$sql[6] = " {$ut->limit($option['offset']*$option['page_size'], $option['page_size'])} ";
	}
	
	$ar = $database->sql_select_all($sql);
	$c = count($ar);
	if ($mode != 'more') {
		$ar = array_merge($folder_ar,$ar);
	}

	if (isset($params['page']['meta']['plugin_page_folder_cache'][$id])) {
		$x = $params['page']['meta']['plugin_page_folder_cache'][$id];
	} else {
		$x = array();
	}
	function _ex_folder_tree($id, &$ar, &$x, &$arg) {
		global $params;
		foreach ($ar as $v) {
			if ($v['link'] == $id) {
				$x["{$v['id']}"] = $v;
				if (isset($params['page']['meta']['plugin_page_folder_cache'][$v['id']])) {
					if ($arg['page_folder_tree']) {
						$x["{$v['id']}"]['children'] = $params['page']['meta']['plugin_page_folder_cache']["{$v['id']}"];
					}
				}
			}
		}
		foreach ($ar as $v) {
			if ($v['link'] != $id && isset($x["{$v['link']}"])) {
				if ($arg['page_folder_tree']) {
					if (isset($x["{$v['link']}"]) && !is_array($x["{$v['link']}"])) {
						continue;
					}
					$x["{$v['link']}"]['children']["{$v['id']}"] = $v;
					_ex_folder_tree($v['link'], $ar, $x["{$v['link']}"]['children'], $arg);
				}
			}
		}
	}
	_ex_folder_tree($id, $ar, $x, $arg);
	$buff .= ex_folder_writer($x);
	
	if ($more) {
		if ($c > 0 && $c == $option['page_size']) {
			$ofs = $option['offset']+1;
			$buff .= "<p id='plugin_page_folder_more{$id}'><a href='javascript:void(plugin_page_folder_read($id,\"more\",{$ofs}))'>more...</a></p>";
		}
	} else {
		$buff = std_pagination_renderer( $option ).$buff;
	}

$html['meta']['plugin_page_folder_read'] = <<<EOT
	<script>
		plugin_page_folder_read = function (link,md,ofs) {
			if (md == 'open' && \$('#plugin_page_folder'+link+' .open_hnd').length) {
				\$('#plugin_page_folder'+link+' .open_hnd').toggle();
				return;
			}
			var opt = "ajax=*plugin_page_folder_read&link="+link+"&xtoken="+ot.magic_str;
			if (md) { opt+="&mode="+md }
			if (ofs) { opt+="&offset="+ofs }
			ot.ajax({
				type: "POST"
				, url: '{$params['safe_request']}'
				, data: opt
				, dataType:'json'
				, success: function(data){
					if (data['mode'] == 'open') {
						var a = "<div class='open_hnd' style='padding-left:20px;'>"+data['html']+"</div>";
						\$('#plugin_page_folder'+data['id']).append(a);
					} else {
						\$('#plugin_page_folder_more'+data['id']).after(data['html']).remove();
					}
				}
			});
		};
	</script>
EOT;

	if ($arg['allow_post'] || isset($params['edit-right']) || check_rights('edit')) {
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_page_folder_reset_cache')  {
			$r = array();
			$r['id'] = $params['page']['id'];
			$r['meta'] = $params['page']['meta'];
			if (isset($r['meta']['plugin_page_folder_cache'])) {
				unset($r['meta']['plugin_page_folder_cache']);
			}
			$r['metadata'] = serialize64($r['meta']);
			if (mod_data_items($r)) {
				$r['result'] = true;
			}
			echo( json_encode($r) );
			exit();
		}
$html['meta']['plugin_page_folder_reset_cache'] = <<<EOT
		<script>
			ot.plugin_page_folder_reset_cache = function (link,type) {
				var opt = "ajax=plugin_page_folder_reset_cache";
				ot.ajax({
					type: "POST"
					, url: '{$params['safe_request']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							location.reload(true);
						} else {
							alert('error');
						}
					}
				});
			};
			ot.plugin_page_folder_ondragstart = function (ev, id) {
				ot.plugin_page_folder_drag_id = id;
				ev.stopPropagation();
			};
			ot.plugin_page_folder_ondragover = function (ev) {
				ev.preventDefault();
				ev.stopPropagation();
				\$('.plugin-page-folder-unit .item ').removeClass('drop');
				\$(ev.currentTarget).addClass('drop');
			};
			ot.plugin_page_folder_ondragend = function (ev) {
				\$('.plugin-page-folder-unit .item ').removeClass('drop');
			};
			ot.plugin_page_folder_ondrop = function (ev,id) {
				ev.preventDefault();
				event.stopPropagation();
				var o = \$('#plugin_page_folder'+ot.plugin_page_folder_drag_id);
				var j = \$('#plugin_page_folder'+id);
				if (j.hasClass('folder')) {
					if (o.hasClass('folder') && j.prev().attr('id') != o.attr('id')) {
						j.before(o);
						j = j.parent();
					} else {
						var k = j.children('.open_hnd').children('div:first');
						if (k.length) {
							k.before(o);
							j = j.children('.open_hnd');
						} else {
							j.children('.open_hnd').append(o);
						}
					}
				} else {
					j.before(o);
					j = j.parent();
				}
				var a = [];
				j.children('.item').each (function(){
					a.push(\$(this).attr('data-idx'));
				});

				var opt = "ajax=plugin_page_folder_ondrop&idx="+j.attr('data-idx');
				opt += "&drag="+ot.plugin_page_folder_drag_id;
				opt += "&drop="+id;
				opt += "&ar="+JSON.stringify(a);
				ot.ajax({
					type: "POST"
					, url: '{$params['safe_request']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
						} else {
							alert('Save error');
						}
					}
				});

			};
			ot.plugin_page_folder_ex = function (id) {
				plugin_page_folder_read(id,'open');
				var opt = "ajax=plugin_page_folder_ex&idx="+id;
				opt += "&ex="+\$('#plugin_page_folder'+id+' .open_hnd:visible').length
				ot.ajax({
					type: "POST"
					, url: '{$params['safe_request']}'
					, data: opt
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
						} else {
							alert('Save error');
						}
					}
				});
			};
		</script>
EOT;

		if (isset($_POST['ajax']) && $_POST['ajax']=='plugin_page_folder_ondrop') {
			$r = array();
			$r['result'] = false;
			$r['id'] = $id;
			$r['idx'] = (int)$_POST['idx'];
			if (!$r['idx']) {
				$r['idx'] = $id;
			}
			$x = json_decode($_POST['ar']);
			if (is_array($x)) {
				$y = array();
				foreach ($x as $v) {
					if ($v) { $y["{$v}"] = $v; }
				}
				if (read_pagedata( $r['id'], $p_ar )) {
					$r['meta'] = $p_ar['meta'];
					$r['meta']['plugin_page_folder_cache'][$r['idx']] = $y;

					$r['drag'] = (int)$_POST['drag'];
					//Dropアイテムの親をチェック
					if (read_pagedata( $r['drag'], $p_ar )) {
						if ($p_ar['link'] != $r['idx']) {
							//Dragアイテムが違う親にDropされた場合、リンク先を移動
							$r['drag_old_parent'] = $p_ar['link'];
							$p_ar['link'] = $r['idx'];
							if (mod_data_items($p_ar)) {
								if (isset($r['meta']['plugin_page_folder_cache'][$r['drag_old_parent']][$r['drag']])) {
									unset($r['meta']['plugin_page_folder_cache'][$r['drag_old_parent']][$r['drag']]);
								}
							}
							//移動元/先のフォルダに無効エントリがないか一応クリーンナップ
							$nx = array();
							foreach ($r['meta']['plugin_page_folder_cache'][$r['drag_old_parent']] as $v) {
								if (read_pagedata( $v, $p_ar )) {
									if ($p_ar['link'] == $r['drag_old_parent']) {
										$nx[$p_ar['id']] = $p_ar['id'];
									}
								}
							}
							$r['meta']['plugin_page_folder_cache'][$r['drag_old_parent']] = $nx;
							$nx = array();
							foreach ($r['meta']['plugin_page_folder_cache'][$r['idx']] as $v) {
								if (read_pagedata( $v, $p_ar )) {
									if ($p_ar['link'] == $r['idx']) {
										$nx[$p_ar['id']] = $p_ar['id'];
									}
								}
							}
							$r['meta']['plugin_page_folder_cache'][$r['idx']] = $nx;
						}
					}
					$r['metadata'] = serialize64($r['meta']);
					if (mod_data_items($r)) {
						$r['result'] = true;
					}
				}
			}
			echo( json_encode($r) );
			exit();
		}
		if (isset($_POST['ajax']) && $_POST['ajax']=='plugin_page_folder_ex') {
			$r = array();
			$r['idx'] = (int)$_POST['idx'];
			$r['ex'] = (int)$_POST['ex'];
			$r['id'] = $params['page']['id'];
			$r['meta'] =$params['page']['meta'];
			if (!$r['ex']) {
				$r['meta']['plugin_page_folder_collapse'][$r['idx']] = true;
			} else {
				unset($r['meta']['plugin_page_folder_collapse'][$r['idx']]);
			}
			$r['metadata'] = serialize64($r['meta']);
			if (mod_data_items($r)) {
				$r['result'] = true;
			}
			echo( json_encode($r) );
			exit();
		}

	}

	if (isset($_GET['ajax']) && $_GET['ajax'] == '*plugin_page_folder_read')  {
		$r = array();
		$r['id'] = $id;
		$r['mode'] = $mode;
		$r['url'] = $ut->link($id);
		$r['html'] = $buff;
		$r['ar'] = $ar;
		echo( json_encode($r) );
		exit();
	}

	return $buff;
}

function ex_folder_writer( &$ar )
{
	global $ut,$html,$config,$params;
	
	$buff = '';
	$nt = time();
	foreach ($ar as $k=>$v) {
		if (!is_array($v)) { 
			//削除されたページがキャッシュされている場合（ページ移動動作で自動ガベージ）
			continue;
		}
		if (empty($v['id'])) { 
			/*$v = array();
			$v['title'] = 'error'.$k;
			$v['id'] = $v['mode'] = $v['type'] = 0;
			$v['date'] = '';
			*/
			//リストの数が、maxカウントにより抑制されている場合、インデックスが見つからずにエラーが起きる場合あり
			continue;
		}
		$m = unserialize64($v['metadata']);
		$t = $v['title'];
		$lang = trim($params['url_prefix'],' /');
		if ($lang && !empty($m['lang'][$lang]['title'])) {
			$t = $m['lang'][$lang]['title'];
			$m['description'] = '';	//仕様が複雑になるので見送り
		}
		$ico = '';
		if (!$t) { $t = '...'; }
		$u = $ut->link($v['id']);
		$c = 'item';
		if ($v['type'] == PAGE_FOLDER_ID || isset($v['children'])) {
			$ico = $ut->icon('folder',"width='16'");
			$u = "javascript:void(plugin_page_folder_read({$v['id']},\"open\"))";
			$c = 'folder item';
		} else {
			$ico = $ut->icon('text2',"width='16'");
		}
		if ($v['mode'] == 0) {
			if (!check_rights('edit') && isset($_SESSION['login_id']) && $v['user'] != $_SESSION['login_id']) { continue; }
			$t = $t.$ut->icon('lock','width="16"');
		} else if ($v['block_type'] >= 15) {
			$t = $t.$ut->icon('lock','width="16"');
		}
		$d = substr($v['date'],0,10);
		if (strtotime($v['date']) > $nt - 60*60*24*14) {
			$d .= "<span class='new'>new</span>";
		}
$buff .= <<<EOT
		<div id='plugin_page_folder{$v['id']}' class='$c' data-idx='{$v['id']}' 
			ondragstart='ot.plugin_page_folder_ondragstart(event,{$v['id']})'
			ondragover='ot.plugin_page_folder_ondragover(event)'
			ondrop='ot.plugin_page_folder_ondrop(event,{$v['id']})'
			ondragend='ot.plugin_page_folder_ondragend(event,{$v['id']})'
			draggable='true'
		>
			<a href='{$u}' >{$ico} </a> 
			<a href='{$ut->link($v['id'])}' >{$t}</a>
			<span class='date'>{$d}</span>
EOT;
			if (isset($v['children']) && $v['type'] == PAGE_FOLDER_ID && check_rights('edit')) {
$buff .= <<<EOT
				{$ut->icon('dn'," class='ex_icon' onclick='ot.plugin_page_folder_ex({$v['id']})' width='20' ")}
EOT;
			}
			if (!empty($m['description'])) {
$buff .= <<<EOT
				<p>{$m['description']}</p>
EOT;
			}
			if ($v['type'] == PAGE_FOLDER_ID || isset($v['children'])) {
				$dsip = '';
				if (isset($params['page']['meta']['plugin_page_folder_collapse'][$v['id']])) {
					$dsip = 'display:none';
				}
$buff .= <<<EOT
				<div class="open_hnd" style="padding-left:20px;{$dsip}" data-idx='{$v['id']}' >
EOT;
					if (isset($v['children']) && is_array($v['children'])) {
						$buff .= ex_folder_writer( $v['children'] );
					}
$buff .= <<<EOT
				</div>
EOT;
			}
$buff .= <<<EOT
		</div>
EOT;
	}

	return $buff;
}


?>